diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.c freeciv-patched/common/unittype.c
--- freeciv-cvs/common/unittype.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/unittype.c	2003-06-30 12:33:10.000000000 +0100
@@ -17,12 +17,16 @@
 
 #include <assert.h>
 #include <string.h>
+#include <ctype.h>
 
 #include "astring.h"
 #include "fcintl.h"
 #include "game.h"
 #include "government.h"
+#include "log.h"
 #include "mem.h"
+#include "member.h"
+#include "modifier.h"
 #include "player.h"
 #include "shared.h"
 #include "support.h"
@@ -30,7 +34,30 @@
 
 #include "unittype.h"
 
+struct atoken {
+  enum {
+    NULL_TOKEN,
+    OP_TOKEN,
+    EQUALS_TOKEN,
+    LEFTPAREN_TOKEN,
+    RIGHTPAREN_TOKEN,
+    IF_TOKEN,
+    STRING_TOKEN,
+    IDENT_TOKEN
+  } type;
+  char *str;
+  char optype;
+  bool has_equals;
+};
+
+char *action_getline(char **iter, struct astring *str);
+void action_doline(void *structpt, struct members *memberlist, char *line);
+void action_parsetokens(void *structpt, struct members *memberlist,
+    			struct atoken *tokens, int numtokens);
+
 struct unit_type unit_types[U_LAST];
+struct modifier_type unit_modifier_types[MAX_MODS];
+struct modifier *unit_modifiers = NULL;
 /* the unit_types array is now setup in:
    server/ruleset.c (for the server)
    client/packhand.c (for the client)
@@ -52,9 +79,11 @@
   "DefendOk", "DefendGood", "AttackFast", "AttackStrong",
   "Ferryboat", "Barbarian", "BarbarianTech", "BarbarianBoat",
   "BarbarianBuild", "BarbarianBuildTech", "BarbarianLeader",
-  "BarbarianSea", "BarbarianSeaTech"
+  "BarbarianSea", "BarbarianSeaTech", "CanModify"
 };
 
+static void ApplyUnitModAction(struct unit_type *u, char *action);
+
 /**************************************************************************
 Returns 1 if the unit_type "exists" in this game, 0 otherwise.
 A unit_type doesn't exist if one of:
@@ -379,6 +408,27 @@
 }
 
 /**************************************************************************
+  Returns the unit type which is built from the given base type and unit
+  modifiers, or U_LAST if none match.
+**************************************************************************/
+Unit_Type_id find_unit_type_by_modifiers(Unit_Type_id basetype, int *modifiers)
+{
+  unit_type_iterate(uid) {
+    int i;
+    if (unit_types[uid].basetype == basetype) {
+      for (i = 0; i < game.num_unit_modifier_types; ++i) {
+	if (unit_types[uid].modifiers[i] != modifiers[i]) {
+	  break;
+	} else if (i == game.num_unit_modifier_types - 1) {
+	  return uid;
+	}
+      }
+    }
+  } unit_type_iterate_end;
+  return U_LAST;
+}
+
+/**************************************************************************
   Convert unit_move_type names to enum; case insensitive;
   returns 0 if can't match.
 **************************************************************************/
@@ -449,17 +499,31 @@
 **************************************************************************/
 bool can_player_build_unit_direct(struct player *p, Unit_Type_id id)
 {
+  struct unit_type *u;
   Impr_Type_id impr_req;
   Tech_Type_id tech_req;
 
   if (!unit_type_exists(id))
     return FALSE;
+  u = &unit_types[id];
   if (unit_type_flag(id, F_FANATIC)
       && !government_has_flag(get_gov_pplayer(p), G_FANATIC_TROOPS))
     return FALSE;
-  if (get_invention(p,unit_types[id].tech_requirement)!=TECH_KNOWN)
+  if (get_invention(p, u->tech_requirement) != TECH_KNOWN)
     return FALSE;
 
+  /* Check tech requirements of unit modifiers if applicable */
+  if (u->basetype != U_LAST) {
+    int i;
+    for (i = 0; i < game.num_unit_modifier_types; ++i) {
+      if (u->modifiers[i] < U_LAST
+	  && get_invention(p, unit_modifiers[u->modifiers[i]].tech_requirement)
+			   != TECH_KNOWN) {
+	return FALSE;
+      }
+    }
+  }
+
   /* If the unit has a building requirement, we check to see if the player
    * can build that building.  Note that individual cities may not have
    * that building, so they still may not be able to build the unit. */
@@ -654,3 +718,714 @@
     unit_type_free(i);
   } unit_type_iterate_end;
 }
+
+/**************************************************************************
+  Convert unit_modifier_type names to int; case insensitive;
+  returns -1 if can't match.
+**************************************************************************/
+int unit_modifier_type_from_str(const char *s)
+{
+  return modifier_type_from_str(s, unit_modifier_types,
+      				game.num_unit_modifier_types);
+}
+
+/**************************************************************************
+Does a linear search of unit_modifiers[].name
+Returns -1 if none match.
+**************************************************************************/
+int find_unit_modifier_by_name(const char *s)
+{
+  return find_modifier_by_name(s, unit_modifiers, game.num_unit_modifiers);
+}
+
+static void ensure_unique_unit_name(struct unit_type *utype)
+{
+  char *tmpname, *tmporig;
+  int mark = 2;
+  int maxlen = sizeof(utype->name) - 10; /* To allow for longer translations */
+  int maxorig = sizeof(utype->name_orig) - 6;
+
+  assert(maxlen > 0 && maxorig > 0);
+  tmpname = mystrdup(utype->name);
+  tmporig = mystrdup(utype->name_orig);
+
+  /* Make sure that the suffix won't be truncated each time */
+  if (strlen(tmpname) > maxlen) {
+    tmpname[maxlen - 1] = '\0';
+  }
+  if (strlen(tmporig) > maxorig) {
+    tmporig[maxorig - 1] = '\0';
+  }
+
+  while (find_unit_type_by_name(utype->name) != U_LAST) {
+    my_snprintf(utype->name, sizeof(utype->name), _("%s Mk%d"), tmpname,
+		mark);
+    my_snprintf(utype->name_orig, sizeof(utype->name_orig), "%s Mk%d",
+		tmporig, mark++);
+    assert(mark < 100);
+  }
+  free(tmpname);
+  free(tmporig);
+}
+
+Unit_Type_id form_compound_unit(const char *name,
+    				const Unit_Type_id basetype,
+				const int modifiers[MAX_MODS])
+{
+  Unit_Type_id id;
+  struct unit_type *u, *base;
+  struct modifier *mod;
+  int i;
+
+  id = game.num_unit_types;
+  if (id >= U_LAST) {
+    freelog(LOG_FATAL, "form_compound_unit: out of unit types");
+    exit(EXIT_FAILURE);
+  }
+  u = &unit_types[id];
+  base = &unit_types[basetype];
+  utype_copy_members(u, base);
+  u->basetype = basetype;
+  u->effect = NULL;
+  append_effects(&u->effect, base->effect);
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    u->modifiers[i] = modifiers[i];
+  }
+  u->tech_requirement = A_NONE;
+  u->obsoleted_by = -1;
+  u->name_orig[0] = '\0';
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    if (u->modifiers[i] < U_LAST) {
+      mod = &unit_modifiers[u->modifiers[i]];
+      ApplyUnitModAction(u, mod->action);
+    }
+  }
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    if (u->modifiers[i] < U_LAST) {
+      mod = &unit_modifiers[u->modifiers[i]];
+      ApplyUnitModAction(u, mod->final_action);
+      append_effects(&u->effect, mod->effect);
+    }
+  }
+  /* Overwrite the auto-generated name if a name is supplied */
+  if (name && name[0]) {
+    sz_strlcpy(u->name_orig, name);
+  }
+  sz_strlcpy(u->name, _(u->name_orig));
+  ensure_unique_unit_name(u);
+  game.num_unit_types++;
+  return id;
+}
+
+static void read_moverate(void *structpt, unsigned long offset,
+                          const size_t size, struct section_file *file,
+                          const char *sec, const char *membername)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  *member = secfile_lookup_int(file, "%s.%s", sec, membername)
+            * SINGLE_MOVE;
+}
+
+static void set_moverate(void *structpt, unsigned long offset,
+                         const size_t size, const char *val)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  *member = SINGLE_MOVE * atoi(val);
+}
+
+static void get_moverate(const void *structpt, unsigned long offset,
+    			 struct memberdata *data)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  my_snprintf(data->str, sizeof(data->str), "%d", *member / SINGLE_MOVE);
+}
+
+static void set_unit(void *structpt, unsigned long offset, const size_t size,
+                     const char *val)
+{
+}
+
+static void get_unit(const void *structpt, unsigned long offset,
+    		     struct memberdata *data)
+{
+}
+
+static void read_movetype(void *structpt, unsigned long offset,
+                          const size_t size, struct section_file *file,
+                          const char *sec, const char *membername)
+{
+  char *str;
+  enum unit_move_type *member = FC_STRUCT_MEMBER_P(enum unit_move_type,
+                                                   structpt, offset);
+
+  str = secfile_lookup_str(file, "%s.%s", sec, membername);
+  if ((*member = unit_move_type_from_str(str)) == 0) {
+    freelog(LOG_FATAL, "for unit_type \"%s\": bad move_type %s",
+	    ((struct unit_type *)structpt)->name, str);
+    exit(EXIT_FAILURE);
+  }
+//printf("Read %s -> (movetype) %s\n", membername, str);
+}
+
+static void set_movetype(void *structpt, unsigned long offset,
+                         const size_t size, const char *val)
+{
+  enum unit_move_type *member = FC_STRUCT_MEMBER_P(enum unit_move_type,
+                                                   structpt, offset);
+
+  if ((*member = unit_move_type_from_str(val)) == 0) {
+    freelog(LOG_FATAL, "bad move type %s", val);
+  }
+}
+
+static void get_movetype(const void *structpt, unsigned long offset,
+    			 struct memberdata *data)
+{
+  enum unit_move_type *member = FC_STRUCT_MEMBER_P(enum unit_move_type,
+                                                   structpt, offset);
+
+  sz_strlcpy(data->str, move_type_names[*member - LAND_MOVING]);
+}
+
+static void read_flags(void *structpt, unsigned long offset, const size_t size,
+                       struct section_file *file,
+                       const char *sec, const char *membername)
+{
+  char **slist, *str;
+  int nval, i;
+  enum unit_flag_id flag;
+  bv_flags *member = FC_STRUCT_MEMBER_P(bv_flags, structpt, offset);
+
+  BV_CLR_ALL(*member);
+  slist = secfile_lookup_str_vec(file, &nval, "%s.%s", sec, membername);
+  for (i = 0; i < nval; ++i) {
+    str = slist[i];
+    if (strcmp(str, "") == 0) {
+      continue;
+    }
+    if (strcmp(str, "Submarine")==0) {
+      /* Backwards compatibility */
+      freelog(LOG_NORMAL, "Old-style \"Submarine\" flag (ok)");
+      BV_SET(*member, F_NO_LAND_ATTACK);
+      BV_SET(*member, F_MISSILE_CARRIER);
+      flag = F_PARTIAL_INVIS;
+    } else {
+      flag = unit_flag_from_str(str);
+    }
+    if (flag == F_MAX) {
+      freelog(LOG_ERROR, "for unit_type \"%s\": bad flag name \"%s\"",
+	      ((struct unit_type *)structpt)->name, str);
+    } else {
+      BV_SET(*member, flag);
+    }
+  }
+  free(slist);
+//printf("Read %s -> (flag) %u\n", membername, *member);
+}
+
+#define FLAGS_MAX_TOKENS 80
+static void set_flags(void *structpt, unsigned long offset, const size_t size,
+                      const char *val)
+{
+  bv_flags *member = FC_STRUCT_MEMBER_P(bv_flags, structpt, offset);
+  char *tokens[FLAGS_MAX_TOKENS];
+  int numtokens, i;
+  enum unit_flag_id flag;
+
+  BV_CLR_ALL(*member);
+  numtokens = get_tokens(val, tokens, FLAGS_MAX_TOKENS, " ,");
+  for (i = 0; i < numtokens; ++i) {
+    flag = unit_flag_from_str(tokens[i]);
+    if (flag == F_MAX) {
+      freelog(LOG_NORMAL, "bad flag name \"%s\" - ignoring", tokens[i]);
+    } else {
+      BV_SET(*member, flag);
+    }
+    free(tokens[i]);
+  }
+}
+
+static void get_flags(const void *structpt, unsigned long offset,
+    		      struct memberdata *data)
+{
+  enum unit_flag_id i;
+  bool first = TRUE;
+  bv_flags *member = FC_STRUCT_MEMBER_P(bv_flags, structpt, offset);
+
+  data->str[0] = '\0';
+  for (i = 0; i < game.num_unit_flags; ++i) {
+    if (BV_ISSET(*member, i)) {
+      if (!first) {
+	sz_strlcat(data->str, ", ");
+      } else {
+	first = FALSE;
+      }
+      sz_strlcat(data->str, "'");
+      sz_strlcat(data->str, flag_names[i]);
+      sz_strlcat(data->str, "'");
+    }
+  }
+
+  freelog(LOG_DEBUG, "(flag) = %s\n", data->str);
+}
+
+static void binary_roleflags(const char *arg1, const char *arg2, const char op,
+			     struct memberdata *result)
+{
+  if (op == '+') {
+    sz_strlcpy(result->str, arg1);
+    if (arg1[0] && arg2[0]) {
+      sz_strlcat(result->str, ", ");
+    }
+    sz_strlcat(result->str, arg2);
+  } else if (op == '-') {
+    freelog(LOG_NORMAL, "Fixme...");
+  }
+}
+
+static void read_roles(void *structpt, unsigned long offset, const size_t size,
+                       struct section_file *file,
+                       const char *sec, const char *membername)
+{
+  char **slist, *str;
+  int nval, i;
+  enum unit_role_id role;
+  bv_roles *member = FC_STRUCT_MEMBER_P(bv_roles, structpt, offset);
+
+  BV_CLR_ALL(*member);
+  slist = secfile_lookup_str_vec(file, &nval, "%s.%s", sec, membername);
+  for (i = 0; i < nval; ++i) {
+    str = slist[i];
+    if (strcmp(str, "") == 0) {
+      continue;
+    }
+    role = unit_role_from_str(str);
+    if (role == L_LAST) {
+      freelog(LOG_ERROR, "for unit_type \"%s\": bad role name \"%s\"",
+	      ((struct unit_type *)structpt)->name, str);
+    } else {
+      BV_SET(*member, role - L_FIRST);
+    }
+  }
+  free(slist);
+//printf("Read %s -> (role) %u\n", membername, *member);
+}
+
+static void set_roles(void *structpt, unsigned long offset, const size_t size,
+                      const char *val)
+{
+}
+
+static void get_roles(const void *structpt, unsigned long offset,
+    		      struct memberdata *data)
+{
+  enum unit_role_id i;
+  bool first = TRUE;
+  bv_roles *member = FC_STRUCT_MEMBER_P(bv_roles, structpt, offset);
+
+  data->str[0] = '\0';
+  for (i = L_FIRST; i < L_LAST; ++i) {
+    if (BV_ISSET(*member, (i - L_FIRST))) {
+      if (!first) {
+	sz_strlcat(data->str, ", ");
+      } else {
+	first = FALSE;
+      }
+      sz_strlcat(data->str, "'");
+      sz_strlcat(data->str, role_names[i - L_FIRST]);
+      sz_strlcat(data->str, "'");
+    }
+  }
+
+  freelog(LOG_DEBUG, "(role) = %s\n", data->str);
+}
+
+#define FC_UTYPE_OFFSET(member) \
+    FC_STRUCT_OFFSET(struct unit_type, member)
+#define FC_UTYPE_SIZE(member) \
+    FC_MEMBER_SIZE(struct unit_type, member)
+
+static struct members utype_members[] = {
+  { "name",
+    FC_UTYPE_OFFSET(name_orig),
+    FC_UTYPE_SIZE(name_orig),
+    NULL, set_string, get_string, binary_string },
+  { "tech_req", FC_UTYPE_OFFSET(tech_requirement),
+    FC_UTYPE_SIZE(tech_requirement), NULL, set_tech, get_tech, NULL },
+  { "impr_req", FC_UTYPE_OFFSET(impr_requirement),
+    FC_UTYPE_SIZE(impr_requirement), NULL, set_int, get_int, NULL },
+  { "obsolete_by", FC_UTYPE_OFFSET(obsoleted_by), FC_UTYPE_SIZE(obsoleted_by),
+    NULL, set_unit, get_unit, NULL },
+  { "move_type", FC_UTYPE_OFFSET(move_type), FC_UTYPE_SIZE(move_type),
+    read_movetype, set_movetype, get_movetype, binary_int },
+  { "sound_move", FC_UTYPE_OFFSET(sound_move), FC_UTYPE_SIZE(sound_move),
+    read_sound, set_string, get_string, binary_string },
+  { "sound_move_alt", FC_UTYPE_OFFSET(sound_move_alt),
+    FC_UTYPE_SIZE(sound_move_alt), read_sound, set_string, get_string,
+    binary_string },
+  { "sound_fight", FC_UTYPE_OFFSET(sound_fight), FC_UTYPE_SIZE(sound_fight),
+    read_sound, set_string, get_string, binary_string },
+  { "sound_fight_alt", FC_UTYPE_OFFSET(sound_fight_alt),
+    FC_UTYPE_SIZE(sound_fight_alt), read_sound, set_string, get_string,
+    binary_string },
+  { "graphic", FC_UTYPE_OFFSET(graphic_str), FC_UTYPE_SIZE(graphic_str),
+    read_string, set_string, get_string, binary_string },
+  { "graphic_alt", FC_UTYPE_OFFSET(graphic_alt), FC_UTYPE_SIZE(graphic_alt),
+    read_string, set_string, get_string, binary_string },
+  { "build_cost", FC_UTYPE_OFFSET(build_cost), FC_UTYPE_SIZE(build_cost),
+    read_int, set_int, get_int, binary_int },
+  { "pop_cost", FC_UTYPE_OFFSET(pop_cost), FC_UTYPE_SIZE(pop_cost),
+    read_int, set_int, get_int, binary_int },
+  { "attack", FC_UTYPE_OFFSET(attack_strength),
+    FC_UTYPE_SIZE(attack_strength), read_int, set_int, get_int, binary_int },
+  { "defense", FC_UTYPE_OFFSET(defense_strength),
+    FC_UTYPE_SIZE(defense_strength), read_int, set_int, get_int, binary_int },
+  { "move_rate", FC_UTYPE_OFFSET(move_rate), FC_UTYPE_SIZE(move_rate),
+    read_moverate, set_moverate, get_moverate, binary_int },
+  { "vision_range", FC_UTYPE_OFFSET(vision_range), FC_UTYPE_SIZE(vision_range),
+    read_int, set_int, get_int, binary_int },
+  { "transport_cap", FC_UTYPE_OFFSET(transport_capacity),
+    FC_UTYPE_SIZE(transport_capacity), read_int, set_int, get_int,
+    binary_int },
+  { "hitpoints", FC_UTYPE_OFFSET(hp), FC_UTYPE_SIZE(hp),
+    read_int, set_int, get_int, binary_int },
+  { "firepower", FC_UTYPE_OFFSET(firepower), FC_UTYPE_SIZE(firepower),
+    read_int, set_int, get_int, binary_int },
+  { "fuel", FC_UTYPE_OFFSET(fuel), FC_UTYPE_SIZE(fuel),
+    read_int, set_int, get_int, binary_int },
+  { "uk_happy", FC_UTYPE_OFFSET(happy_cost), FC_UTYPE_SIZE(happy_cost),
+    read_int, set_int, get_int, binary_int },
+  { "uk_shield", FC_UTYPE_OFFSET(shield_cost), FC_UTYPE_SIZE(shield_cost),
+    read_int, set_int, get_int, binary_int },
+  { "uk_food", FC_UTYPE_OFFSET(food_cost), FC_UTYPE_SIZE(food_cost),
+    read_int, set_int, get_int, binary_int },
+  { "uk_gold", FC_UTYPE_OFFSET(gold_cost), FC_UTYPE_SIZE(gold_cost),
+    read_int, set_int, get_int, binary_int },
+  { "flags", FC_UTYPE_OFFSET(flags), FC_UTYPE_SIZE(flags),
+    read_flags, set_flags, get_flags, binary_roleflags },
+  { "roles", FC_UTYPE_OFFSET(roles), FC_UTYPE_SIZE(roles),
+    read_roles, set_roles, get_roles, binary_roleflags },
+  { "paratroopers_range", FC_UTYPE_OFFSET(paratroopers_range),
+    FC_UTYPE_SIZE(paratroopers_range), NULL, set_int, get_int, binary_int },
+  { "paratroopers_mr_req", FC_UTYPE_OFFSET(paratroopers_mr_req),
+    FC_UTYPE_SIZE(paratroopers_mr_req), NULL, set_moverate, get_moverate,
+    binary_int },
+  { "paratroopers_mr_sub", FC_UTYPE_OFFSET(paratroopers_mr_sub),
+    FC_UTYPE_SIZE(paratroopers_mr_sub), NULL, set_moverate, get_moverate,
+    binary_int },
+  { NULL, 0, 0, NULL, NULL, NULL, NULL }
+};
+
+void utype_copy_members(struct unit_type *dest, const struct unit_type *src)
+{
+  copy_members((void *)dest, (const void *)src, utype_members);
+}
+
+void utype_read_members(struct unit_type *utype,
+                        struct section_file *file, const char *sec)
+{
+  read_members((void *)utype, utype_members, file, sec);
+}
+
+void utype_read_member(struct unit_type *utype, const char *membername,
+    		       struct section_file *file, const char *sec)
+{
+  read_member((void *)utype, utype_members, membername, file, sec);
+}
+
+void utype_set_member(struct unit_type *utype, const char *membername,
+                      const char *val)
+{
+  set_member((void *)utype, utype_members, membername, val);
+}
+
+void utype_get_member(struct unit_type *utype, const char *membername,
+    		      struct memberdata *data)
+{
+  get_member((void *)utype, utype_members, membername, data);
+}
+
+char *action_getline(char **iter, struct astring *str)
+{
+  int linelen;
+  char *startline = *iter;
+
+  startline += strspn(startline, "\r\n\t ");
+  linelen = my_strcspn(startline, "\r\n");
+  if (linelen) {
+    astr_minsize(str, linelen + 1);
+    mystrlcpy(str->str, startline, linelen + 1); /* to add the '/0' */
+    *iter = startline + linelen;
+  }
+
+  return startline[0] ? str->str : NULL;
+}
+
+static void get_str_data(void *structpt, struct members *memberlist,
+    			 struct atoken *token, struct memberdata *result,
+                         char **identname)
+{
+  if (token->type == STRING_TOKEN) {
+    sz_strlcpy(result->str, token->str);
+  } else if (token->type == IDENT_TOKEN) {
+    get_member(structpt, memberlist, token->str, result);
+    if (identname) {
+      *identname = token->str;
+    }
+  } else {
+    freelog(LOG_NORMAL, "parse error");
+  }
+}
+
+static int find_operator(struct atoken *tokens, int numtokens, char *ops)
+{
+  int i, numparen = 0;
+
+  for (i = 0; i < numtokens; ++i) {
+    switch(tokens[i].type) {
+    case LEFTPAREN_TOKEN:
+      numparen++;
+      break;
+    case RIGHTPAREN_TOKEN:
+      numparen--;
+      break;
+    case OP_TOKEN:
+      if (numparen == 0 && (!ops || strchr(ops, tokens[i].optype))) {
+	return i;
+      }
+      break;
+    default:
+      break;
+    }
+  }
+  if (numparen != 0) {
+    freelog(LOG_NORMAL, "Unbalanced parentheses");
+  }
+  return -1;
+}
+
+static void eval_expr(void *structpt, struct members *memberlist,
+    		      struct atoken *tokens, int numtokens,
+    		      struct atoken *result, char **identname)
+{
+  result->type = STRING_TOKEN;
+  result->str = NULL;
+
+  /* Strip surrounding parentheses */
+  while (numtokens >= 2 && tokens[0].type == LEFTPAREN_TOKEN
+         && tokens[numtokens - 1].type == RIGHTPAREN_TOKEN) {
+    numtokens -= 2;
+    tokens++;
+  }
+
+  if (numtokens == 1) {
+    struct memberdata rhs;
+    size_t len;
+
+    get_str_data(structpt, memberlist, &tokens[0], &rhs, identname);
+    len = strlen(rhs.str) + 1;
+    result->str = fc_malloc(len);
+    mystrlcpy(result->str, rhs.str, len);
+  } else {
+    struct atoken lhs, rhs;
+    struct memberdata member;
+    size_t len;
+    int oppos;
+
+    oppos = find_operator(tokens, numtokens, "+-");
+    if (oppos < 0) {
+      oppos = find_operator(tokens, numtokens, "*/");
+    }
+    if (oppos < 0) {
+      oppos = find_operator(tokens, numtokens, NULL);
+    }
+    if (oppos <= 0 || oppos >= numtokens) {
+      freelog(LOG_NORMAL, "parse error");
+    } else {
+      char *membname = NULL;
+
+      eval_expr(structpt, memberlist, &tokens[0], oppos, &lhs, &membname);
+      eval_expr(structpt, memberlist, &tokens[oppos + 1],
+	  	numtokens - oppos - 1, &rhs, &membname);
+
+      freelog(LOG_DEBUG, "Binary op %c on %s and %s", tokens[oppos].optype,
+              lhs.str, rhs.str);
+
+      if (membname) {
+        binary_member(structpt, memberlist, membname,
+          	      lhs.str, rhs.str, tokens[oppos].optype, &member);
+	if (identname) {
+	  *identname = membname;
+	}
+      } else if (isdigit(lhs.str[0]) || isdigit(rhs.str[0])) {
+        binary_int(lhs.str, rhs.str, tokens[oppos].optype, &member);
+      } else {
+        binary_string(lhs.str, rhs.str, tokens[oppos].optype, &member);
+      }
+      len = strlen(member.str) + 1;
+      result->str = fc_malloc(len);
+      mystrlcpy(result->str, member.str, len);
+    }
+  }
+}
+
+void action_parsetokens(void *structpt, struct members *memberlist,
+    			struct atoken *tokens, int numtokens)
+{
+  struct memberdata data;
+
+  if (numtokens > 4 && tokens[0].type == IF_TOKEN
+      && tokens[2].type == EQUALS_TOKEN) {
+    get_member(structpt, memberlist, tokens[1].str, &data);
+    if (strcmp(data.str, tokens[3].str) == 0) {
+      freelog(LOG_DEBUG, "if %s = %s: TRUE", tokens[1].str, tokens[3].str);
+      action_parsetokens(structpt, memberlist, &tokens[4], numtokens - 4);
+    } else {
+      freelog(LOG_DEBUG, "if %s = %s: FALSE", tokens[1].str, tokens[3].str);
+    }
+  } else if (numtokens >= 3 && tokens[1].type == EQUALS_TOKEN
+	     && tokens[0].type == IDENT_TOKEN) {
+    struct atoken result;
+
+    eval_expr(structpt, memberlist, &tokens[2], numtokens - 2, &result, NULL);
+    freelog(LOG_DEBUG, "%s set to %s", tokens[0].str, result.str);
+    set_member(structpt, memberlist, tokens[0].str, result.str);
+  } else if (numtokens >= 3 && tokens[1].type == OP_TOKEN
+             && tokens[1].has_equals && tokens[0].type == IDENT_TOKEN) {
+    struct atoken rhs;
+    struct memberdata result;
+
+    get_member(structpt, memberlist, tokens[0].str, &data);
+    eval_expr(structpt, memberlist, &tokens[2], numtokens - 2, &rhs, NULL);
+    binary_member(structpt, memberlist, tokens[0].str, data.str, rhs.str,
+        	  tokens[1].optype, &result);
+    freelog(LOG_DEBUG, "%s %c= %s -> %s", tokens[0].str, tokens[1].optype,
+            rhs.str, result.str);
+    set_member(structpt, memberlist, tokens[0].str, result.str);
+  } else {
+    freelog(LOG_NORMAL, "Parse error");
+  }
+}
+
+static void add_op_token(const char **strpt, struct atoken *token)
+{
+  const char *str = *strpt;
+
+  switch(str[0]) {
+  case '(':
+    token->type = LEFTPAREN_TOKEN; break;
+  case ')':
+    token->type = RIGHTPAREN_TOKEN; break;
+  case '=':
+    token->type = EQUALS_TOKEN; break;
+  default:
+    token->type = OP_TOKEN;
+    token->optype = str[0];
+    token->has_equals = FALSE;
+    if (str[1] == '=') {
+      token->has_equals = TRUE;
+      (*strpt)++;
+    }
+    break;
+  }
+  (*strpt)++;
+}
+
+static int action_tokens(const char *str, struct atoken *tokens,
+    			 size_t num_tokens)
+{
+  int token;
+
+  for (token = 0; token < num_tokens; ++token) {
+    tokens[token].str = NULL;
+    tokens[token].type = NULL_TOKEN;
+  }
+
+  token = 0;
+  while (token < num_tokens && str[0] != '\0') {
+    size_t len;
+    const char *stpt;
+    bool strlist;
+
+    switch (str[0]) {
+    case '+': case '-': case '*': case '/':
+    case '(': case ')': case '=':
+      add_op_token(&str, &tokens[token]);
+      token++;
+      break;
+    default:
+      strlist = FALSE;
+      str += strspn(str, "\t, ");
+      stpt = str;
+      len = my_strcspn(str, "\t -+=*/()");
+      while (len > 0 && str[len - 1] == ',' && (strchr("\t ", str[len]))) {
+        strlist = TRUE;
+        str += len;
+        str += strspn(str, "\t, ");
+        len = my_strcspn(str, "\t -+=*/()");
+      }
+      str += len;
+      if (str > stpt) {
+        len = str - stpt;
+        if (strlist) {
+          tokens[token].type = STRING_TOKEN;
+        } else if ((stpt[0] == '\'' && str[-1] == '\'')
+            	   || (stpt[0] == '\"' && str[-1] == '\"')) {
+          len -= 2;
+          stpt++;
+          tokens[token].type = STRING_TOKEN;
+        } else if (!isalpha(stpt[0])) {
+          tokens[token].type = STRING_TOKEN;
+        } else {
+          tokens[token].type = IDENT_TOKEN;
+        }
+        if (strncmp(stpt, "if", len) == 0) {
+          tokens[token].type = IF_TOKEN;
+        } else {
+          tokens[token].str = fc_malloc(len + 1);
+          mystrlcpy(tokens[token].str, stpt, len + 1);
+        }
+        token++;
+      }
+      break;
+    }
+  }
+  return token;
+}
+
+#define ACTION_MAX_TOKENS 80
+void action_doline(void *structpt, struct members *memberlist, char *line)
+{
+  struct atoken atokens[ACTION_MAX_TOKENS];
+  int numtokens, i;
+
+  numtokens = action_tokens(line, atokens, ACTION_MAX_TOKENS);
+  freelog(LOG_DEBUG, "Attempting to apply action line %s", line);
+  action_parsetokens(structpt, memberlist, atokens, numtokens);
+  for (i = 0; i < numtokens; ++i) {
+    free(atokens[i].str);
+  }
+}
+
+void apply_action(void *structpt, struct members *memberlist, char *action)
+{
+  char *iter, *line;
+  struct astring str;
+
+  assert(action);
+  astr_init(&str);
+  iter = action;
+  while ((line = action_getline(&iter, &str)) != NULL) {
+    action_doline(structpt, memberlist, line);
+  }
+  astr_free(&str);
+}
+
+static void ApplyUnitModAction(struct unit_type *u, char *action)
+{
+  apply_action((void *)u, utype_members, action);
+}
+
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.h freeciv-patched/common/unittype.h
--- freeciv-cvs/common/unittype.h	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/unittype.h	2003-06-30 12:33:10.000000000 +0100
@@ -14,6 +14,7 @@
 #define FC__UNITTYPE_H
 
 #include "shared.h"
+#include "modifier.h"
 
 struct player;
 struct city;
@@ -21,6 +22,9 @@
 struct Sprite;			/* opaque; client-gui specific */
 struct unit;
 struct impr_effect;
+struct section_file;
+struct memberdata;
+struct members;
 
 typedef int Unit_Type_id;
 /*
@@ -132,6 +136,7 @@
   L_BARBARIAN_LEADER,   /* barbarian leader */
   L_BARBARIAN_SEA,      /* sea raider unit */
   L_BARBARIAN_SEA_TECH, /* sea raider unit, global tech required */
+  L_CANMODIFY,          /* we can apply unit modifiers to this unit type */
   L_LAST
 };
 #define L_MAX 64
@@ -179,6 +184,9 @@
 
   struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
 
+  Unit_Type_id basetype;  /* if !U_LAST, unit modifiers are applied */
+  int modifiers[MAX_MODS];
+
   char *helptext;
 };
 
@@ -188,6 +196,8 @@
 };
 
 extern struct unit_type unit_types[U_LAST];
+extern struct modifier_type unit_modifier_types[MAX_MODS];
+extern struct modifier *unit_modifiers;
 
 bool unit_type_exists(Unit_Type_id id);
 struct unit_type *get_unit_type(Unit_Type_id id);
@@ -224,6 +234,7 @@
 
 Unit_Type_id find_unit_type_by_name(const char *s);
 
+Unit_Type_id find_unit_type_by_modifiers(Unit_Type_id basetype, int *modifiers);
 enum unit_move_type unit_move_type_from_str(const char *s);
 enum unit_flag_id unit_flag_from_str(const char *s);
 void unit_flag_set_name(enum unit_flag_id id, const char *s);
@@ -250,4 +261,22 @@
   }                                                                           \
 }
 
+int unit_modifier_type_from_str(const char *s);
+int find_unit_modifier_by_name(const char *s);
+
+Unit_Type_id form_compound_unit(const char *name,
+    				const Unit_Type_id basetype,
+				const int modifiers[MAX_MODS]);
+
+void utype_copy_members(struct unit_type *dest, const struct unit_type *src);
+void utype_read_members(struct unit_type *utype,
+                        struct section_file *file, const char *sec);
+void utype_read_member(struct unit_type *utype, const char *membername,
+    		       struct section_file *file, const char *sec);
+void utype_set_member(struct unit_type *utype, const char *membername,
+                      const char *val);
+void utype_get_member(struct unit_type *utype, const char *membername,
+    		      struct memberdata *data);
+void apply_action(void *structpt, struct members *memberlist, char *action);
+
 #endif  /* FC__UNITTYPE_H */
